aboutsummaryrefslogtreecommitdiffstats
path: root/meta/recipes-core/initscripts/initscripts-1.0/hostname.sh
diff options
context:
space:
mode:
Diffstat (limited to 'meta/recipes-core/initscripts/initscripts-1.0/hostname.sh')
-rwxr-xr-xmeta/recipes-core/initscripts/initscripts-1.0/hostname.sh12
1 files changed, 10 insertions, 2 deletions
diff --git a/meta/recipes-core/initscripts/initscripts-1.0/hostname.sh b/meta/recipes-core/initscripts/initscripts-1.0/hostname.sh
index fb58c9c634..78fb91c409 100755
--- a/meta/recipes-core/initscripts/initscripts-1.0/hostname.sh
+++ b/meta/recipes-core/initscripts/initscripts-1.0/hostname.sh
@@ -7,8 +7,16 @@
# Default-Stop:
# Short-Description: Set hostname based on /etc/hostname
### END INIT INFO
+HOSTNAME=$(/bin/hostname)
-if test -f /etc/hostname
-then
+hostname -b -F /etc/hostname 2> /dev/null
+if [ $? -eq 0 ]; then
+ exit
+fi
+
+# Busybox hostname doesn't support -b so we need implement it on our own
+if [ -f /etc/hostname ];then
hostname -F /etc/hostname
+elif [ -z "$HOSTNAME" -o "$HOSTNAME" = "(none)" -o ! -z "`echo $HOSTNAME | sed -n '/^[0-9]*\.[0-9].*/p'`" ] ; then
+ hostname localhost
fi